require "import"
import "android.media.AudioManager"
import "android.content.Context"
import "android.provider.Settings"
import "android.content.ComponentName"
import "android.content.Intent"
import "android.app.NotificationManager"
import "android.os.Build"

context = activity or service
audioManager = context.getSystemService(Context.AUDIO_SERVICE)
notificationManager = context.getSystemService(Context.NOTIFICATION_SERVICE)

-- 检查并请求通知策略访问权限
function checkNotificationPolicyAccess()
if Build.VERSION.SDK_INT >= Build.VERSION_CODES.M then
if not notificationManager.isNotificationPolicyAccessGranted() then
local intent = Intent(Settings.ACTION_NOTIFICATION_POLICY_ACCESS_SETTINGS)
intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
context.startActivity(intent)
return false
end
end
return true
end

function setSoundMode(mode)
if not checkNotificationPolicyAccess() then
print("请先授予通知策略访问权限")
return false
end

local currentMode = audioManager.getRingerMode()
if mode == "silent" and currentMode ~= AudioManager.RINGER_MODE_SILENT then
audioManager.setRingerMode(AudioManager.RINGER_MODE_SILENT)
elseif mode == "normal" and currentMode ~= AudioManager.RINGER_MODE_NORMAL then
audioManager.setRingerMode(AudioManager.RINGER_MODE_NORMAL)
end
end

local currentMode = audioManager.getRingerMode()
if currentMode == AudioManager.RINGER_MODE_NORMAL then
setSoundMode("silent")  -- 切换到静音模式
service.asyncSpeak("静音模式")
else
setSoundMode("normal")  -- 切换到正常模式
service.asyncSpeak("响铃模式")
if currentMode ~= AudioManager.RINGER_MODE_SILENT then
service.playSoundTick()
end
end

return true